/**********************************************************************
* udp-broadcast-send-socket.c
*
* Copyright(C), Yacer Communication Technology Co., Ltd.
* All rights reserved.              http://www.yacer.cn
*
***********************************************************************
* 2016-12-23    yacer   created
*
**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <winsock.h>

/*
 * UDPȫ㲥255.255.255.255) socket
 */
int yacer_udp_broadcast_send(char *local_ip_address,    /* ȫ㲥IPַ */
                             unsigned short dest_port,  /* ĿUDP˿ں    */
                             char *pData,               /*        */
                             int data_length            /* ݳȣֽ */
                             )
{
    unsigned short wVersionRequested;
	WSADATA wsaData;
	int ret;
	int sndSocket;
	int broadcastFlag;
    struct sockaddr_in loacalAddr, remoteAddr;

    /*  windows socket */
	wVersionRequested=MAKEWORD(2,2);
	WSAStartup(wVersionRequested,&wsaData);

    /* ׽ */
    sndSocket = socket(AF_INET,
                       SOCK_DGRAM,  /* UDP  */
                       0);

    /* ȫ㲥󶨱ԸЭջĸڷ */
    memset(&loacalAddr, 0, sizeof(loacalAddr));
    loacalAddr.sin_family = AF_INET;
    loacalAddr.sin_addr.s_addr = inet_addr(local_ip_address);
    loacalAddr.sin_port = 0;    /* Ϊ0ʾϵͳԶԴ˿ڣҪ˹ָ˴дĶ˿ں */

    bind(sndSocket, (struct sockaddr *)&loacalAddr, sizeof(loacalAddr));

    /* ø׽ֹ֧㲥 */
    broadcastFlag = 1;
    setsockopt(sndSocket, SOL_SOCKET, SO_BROADCAST, (char *) &broadcastFlag, sizeof(broadcastFlag));

    /* ͵ַʼ */
    memset(&remoteAddr, 0, sizeof(remoteAddr));
    remoteAddr.sin_family = AF_INET;
    remoteAddr.sin_addr.s_addr = INADDR_BROADCAST;     /* ĿĵַΪ㲥ַ */
    remoteAddr.sin_port = htons(dest_port);

    /*  */
    ret = sendto(sndSocket, (char *)pData, data_length, 0, (struct sockaddr*)&remoteAddr, sizeof(remoteAddr));
    if (ret == SOCKET_ERROR)
    {
        printf("send failure");
    }
    else
    {
        printf("send success");
    }

    /*
     * һUDPģи෢Ͳڴ˴ִ
     */

    /* ȫϣر׽ */
    closesocket(sndSocket);

    /* ر windows socket */
    WSACleanup();

    return ret;
}
